const webpack = require("webpack");
// 配置手册： https://cli.vuejs.org/zh/config/#vue-config-js
const { defineConfig } = require("@vue/cli-service");

const defProxy = {
  "/api": {
    target: process.env.VUE_APP_MAIN_PROXY,
    changeOrigin: true,
  },
  "/file": {
    target: process.env.VUE_APP_MAIN_PROXY_FILE,
    changeOrigin: true,
  },
};

module.exports = defineConfig({
  transpileDependencies: [/\bvue-awesome\b/],
  // publicPath: './',
  devServer: {
    port: 8066,
    proxy: defProxy,
    // https://webpack.js.org/configuration/dev-server/#overlay
    client: {
      overlay: false,
    },
  },
  configureWebpack: {
    devtool: "source-map",
    plugins: [
      // Ignore all locale files of moment.js
      new webpack.IgnorePlugin({
        resourceRegExp: /^\.\/locale$/,
        contextRegExp: /moment$/,
      }),
    ],
  },
});
